//
//  ProfilePresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/8/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift
import RxCocoa
import Action

enum ProfileNavigationOption {
    case profileSettings
    case editMembershipinfo(membership: Membership)
    case createTransaction(membership: Membership)
}
protocol ProfileWireframeInterface: WireframeInterface {
    func navigate(to option: ProfileNavigationOption)
}

protocol ProfileViewInterface: ViewInterface {
    var dataPresenter: BehaviorRelay<ProfileDataPresenter?> { get }
}

final class ProfilePresenter: ProfilePresenterInterface {
    
    let editMembershipProfileTrigger = PublishRelay<Void>()
    let selectedSettingsTrigger = PublishRelay<Void>()
    let createTransactionTrigger = PublishRelay<Void>()
    // MARK: - Private properties -
    
    //    private lazy var getProfileAction = makeGetProfileAction()
    private let disposeBag = DisposeBag()
    
    private unowned let view: ProfileViewInterface
    private let interactor: ProfileInteractorInterface
    private let wireframe: ProfileWireframeInterface
    
    private let membership: Membership
    
    // MARK: - Lifecycle -
    
    init(view: ProfileViewInterface,
         interactor: ProfileInteractorInterface,
         wireframe: ProfileWireframeInterface,
         membership: Membership) {
        
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        self.membership = membership
        
        configurePresenter()
        configureViewActions()
    }
}

// MARK: - Extensions -

extension ProfilePresenter {
    
    func configurePresenter() {
        
        Observable
            .just(membership)
            .map { ProfileDataPresenter(model: $0) }
            .bind(to: view.dataPresenter)
            .disposed(by: disposeBag)
    }
    
    func configureViewActions() {
        selectedSettingsTrigger
            .subscribeNext { [weak wireframe] in
                wireframe?.navigate(to: .profileSettings)
            }
            .disposed(by: disposeBag)
        
        editMembershipProfileTrigger
            .subscribeNext { [weak self]  in
                guard let self = self else { return }
                self.wireframe.navigate(to: .editMembershipinfo(membership: self.membership))
            }
            .disposed(by: disposeBag)
        
        createTransactionTrigger
            .subscribeNext { [weak self] in
                guard let self = self else { return }
                self.wireframe.navigate(to: .createTransaction(membership: self.membership))
            }
            .disposed(by: disposeBag)
        
    }
}

struct ProfileDataPresenter {
    private var header: [ProfileCellType] = []
    private var appInfos: [ProfileCellType] = [.feedback, .shareOurApp]
    private var activies: [ProfileCellType] = [.message, .comment, .level]
    private var transactions: [ProfileCellType] = [.createNewTransaction, .transactionsHistory]
    
    init(model: Membership) {
        header = [ .header(viewModel: ProfileHeaderViewModel(model: model))]
    }
    
    func joined() -> [ProfileCellType] {
        return header + [.divider] + activies + [.divider] +  appInfos +  [.divider] + transactions
    }
}
